unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.UITypes, Vcl.Mask;
type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Memo1: TMemo;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);

  private
   { Private declarations }
  public
   { Public declarations }
  end;

MyThread=class(Tthread)
private
{ private declarations }
protected
procedure execute; override;
procedure outtomemo;
end;

var
Form1:TForm1;
Adr:PWideChar;//  COM ;
W:WideString;// ;
ComFile:THandle;//  ;
Dcb:TDCB; //  ;
ComStat:TComStat;//  ;
Timeouts:TCommTimeouts;// ;
OverRead:TOverlapped;
Buffer:array [0..255] of AnsiChar;//  AnsiChar;
MyThr:MyThread;//  ;
Btr, Temp, Mask, Signal:DWORD;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);// ,    listBox;
Var i:Integer;
begin
 for i:=0 to 10 do
  begin
   ComFile:=CreateFile(Pchar('COM'+intToStr(i+1)), Generic_Read or Generic_Write, 0, nil, open_existing, file_flag_overlapped,0);
    if ComFile<>invalid_handle_value then
    begin
    Listbox1.Items.Add('COM'+ IntToStr(i+1));
    CloseHandle(ComFile);
    end;
   Button1.Enabled:=False;//  ;
   end;
 end;

procedure TForm1.Button2Click(Sender: TObject);// listBox,  ,  ;
begin
if  MyThr <> nil then //   ,
MyThr.Terminate;//  ;
ListBox1.Clear;//  ListBox1;
CloseHandle(ComFile);// ;
Button1.Enabled:=True;//   "";
Button2.Enabled:=False;//  "";
Button3.Enabled:=False;//  " ";
ListBox1.Enabled:=True;//ListBox1  ;
end;

procedure TForm1.Button3Click(Sender: TObject);//  ;
begin
MyThr:=MyThread.Create(false);//  ;
MyThr.FreeOnTerminate:=true; //  ;
MyThr.Priority:=tpNormal;// ;
Button3.Enabled:=False;
end;

procedure TForm1.Button4Click(Sender: TObject);// Memo,  ,   .
begin
PurgeComm(ComFile, Purge_TXabort or Purge_RXabort or Purge_TXclear or Purge_RXclear);
Buffer:='';
Memo1.Lines.Clear;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);// ;
begin
if  MyThr <> nil then//  ;
MyThr.Terminate;// ;
CloseHandle(ComFile);// ;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);//  ;
begin
W:=Form1.ListBox1.Items.Strings[form1.ListBox1.ItemIndex];//  ;
Adr:=PWideChar(W);//       ;
ComFile:=CreateFile(Adr, Generic_Read+Generic_Write,0,nil,Open_Existing,File_Flag_Overlapped,0);// ;
if ComFile=Invalid_Handle_Value  then
 begin
 ShowMessage('    ');//  ,    ;
 exit;
 end;

PurgeComm(ComFile, Purge_TXabort or Purge_RXabort or Purge_TXclear or Purge_RXclear);

 GetCommState(ComFile, DCB);// DCB  ;
 with DCB do
 begin
 BaudRate:=9600;
 ByteSize:=8;
 Parity:=NoParity;
 StopBits:=OneStopBit;
 end;
 if not SetCommState(ComFile, DCB) then
 begin
 ShowMessage('  ');//      ;
 CloseHandle(ComFile);
 exit;
 end;

if ComFile <> INVALID_HANDLE_VALUE then
begin
GetCommTimeouts(ComFile, Timeouts); //        CommTimeouts ...
Timeouts.ReadIntervalTimeout:=MAXDWORD; //   ;
Timeouts.ReadTotalTimeoutMultiplier:=0;//   ;
Timeouts.ReadTotalTimeoutConstant:=0;//     ;
Timeouts.WriteTotalTimeoutMultiplier:=0;//   ;
Timeouts.WriteTotalTimeoutConstant:=0; //     ;
SetCommTimeouts(ComFile, Timeouts); // ;
end;

SetupComm(ComFile, 4096, 4096);// ;
if not SetupComm(ComFile, 4096, 4096) then //  ;
begin
ShowMessage('  ');
CloseHandle(ComFile);
exit;
end;

SetCommMask(ComFile, EV_RXchar);//      - "   ";
ListBox1.Enabled:=False;// listbox;
Button2.Enabled:=True;//  "";
Button3.Enabled:=True;//  " ";
end;
{ MyThread }
procedure MyThread.execute;
begin
 OverRead.Hevent:=CreateEvent(Nil, True, True, Nil);//     ;
 While not MyThr.Terminated do//   ;
 begin
  WaitCommEvent(ComFile, Mask, @OverRead);//  ( );
  Signal:=WaitForSingleObject(OverRead.hEvent, Infinite);//        ;
  if (Signal=Wait_Object_0) then //  ;
  begin
   if GetOverlappedResult(ComFile, OverRead, Temp, true) then //   ;
   begin
    if ((Mask and EV_RXchar)<>0) then
    begin
     ClearCommError(ComFile, Temp, @ComStat); //  COMSTAT;
     Btr:=ComStat.CbInQue; //    ;
     If Btr.Size<>0 then //  ,
     begin
     ReadFile(ComFile, Buffer, SizeOf(Buffer), Temp, @OverRead);// ;
     Synchronize(OutToMemo);//      Memo;
     end;
     end;
    end
   end;
  end;
 CloseHandle(OverRead.Hevent);
 end;

procedure MyThread.OutToMemo;//   Memo;
begin
Form1.Memo1.Lines.Text:=Form1.Memo1.Lines.Text+(String(buffer));//  Memo  ;
Buffer:='';//  ;
end;

end.

